/*-
 * Copyright (C)2012 @BABOLO http://www.babolo.ru/
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#ifndef lint
static const char copyright[] = "\
@(#)Copyright (C)2012 @BABOLO http://www.babolo.ru/\n\
@(#)All rights reserved.\n";
static const char rcsid[] = "$Id: test.c,v 1.6 2013/01/26 15:43:58 babolo Exp $";
#endif /* not lint */

#include <sys/types.h>
#include <sysexits.h>
#include <stdlib.h>
#include <stdio.h>
#include <errno.h>
#include <babolo/BLINflag.h>
#include "../transposit.h"

int
main(int argc, char **argv) {
    transposit_deposit *sdp = NULL;
    transposit_2sw *sw;
    FILE *o = stdout;
    size_t k;

    sw = transposit_2swnew(0, 4, 4, 6);
    transposit_2swconn(sw, TRANSPOSIT_EXT, 0, 0, 0);
    transposit_2swconn(sw, TRANSPOSIT_EXT, 1, 0, 1);
    transposit_2swconn(sw, TRANSPOSIT_EXT, 2, 1, 0);
    transposit_2swconn(sw, TRANSPOSIT_EXT, 3, 1, 1);
    transposit_2swconn(sw, 0, 0, 3, 0);
    transposit_2swconn(sw, 0, 1, 2, 0);
    transposit_2swconn(sw, 1, 0, 2, 1);
    transposit_2swconn(sw, 1, 1, 4, 1);
    transposit_2swconn(sw, 2, 0, 3, 1);
    transposit_2swconn(sw, 2, 1, 4, 0);
    transposit_2swconn(sw, 3, 0, TRANSPOSIT_EXT, 0);
    transposit_2swconn(sw, 3, 1, 5, 0);
    transposit_2swconn(sw, 4, 0, 5, 1);
    transposit_2swconn(sw, 4, 1, TRANSPOSIT_EXT, 3);
    transposit_2swconn(sw, 5, 0, TRANSPOSIT_EXT, 1);
    transposit_2swconn(sw, 5, 1, TRANSPOSIT_EXT, 2);
//  transposit_2swdump(sw, o);
    for (k = 0; k < 64; ++k) {
        transposit_switch *swr;

        transposit_2swnetset(sw, &k);
        swr = transposit_2swget(sw, NULL);
//      fprintf(o, "%5u\n", k);
//      transposit_swprint(swr, o);
//      fprintf(o, "0x%02X\n", (u_int8_t)transposit_pack(swr, 0));
        if  (!transposit_swdepo(&sdp, swr, &k, 6)) free(swr);
    }
    transposit_swuniq(sdp, "\077", 6);
    transposit_swsort(&sdp);
    transposit_deprint(sdp, o);
    exit(0);
}
